#include "StdAfx.h"
#include "URItem.h"

URItem::URItem(Bitmap *bitmap) {
	this->bitmap = bitmap;
}

URItem::~URItem() {
	if ( bitmap != NULL ) {
		delete bitmap;
		bitmap = NULL;
	}
}

Bitmap * URItem::getBitmap() {
	return bitmap;
}

URStack::URStack() {
	top = -1;
	for (int i=0; i < MAX_ITEMS; i++) {
		items[i] = NULL;
	}
}

URStack::~URStack() {
	Empty();
}

void URStack::Empty() {
	URItem *it;
	while ( ! isEmpty() ) {
		it = pop();
		if ( it!= NULL ) delete it;
	}
}

void URStack::push(URItem *item) {
	if ( item == NULL ) return;

	if ( top < MAX_ITEMS-1 ) {
		items[++top] = item;
		return;
	}
	// otherwise we have a problem
	// we must move all the items lower in the stack
	// by removing the oldest item
	URItem *oldest = items[0];
	delete oldest;

	for ( int i=0; i < top; i++ ) {
		items[i] = items[i+1];
	}
	items[top] = item;
}

URItem *URStack::pop() {
	URItem *item = NULL;
	if ( ! isEmpty() ) {
		item = items[top--];
	}
	return item;
}

BOOL URStack::isEmpty() {
	return ( top < 0 );
}